#pragma once

#include "GameObject.h"
#include "Spieler.h"

enum GeschossTyp
{
    GESCHOSS_PFEIL,
    GESCHOSS_KUGEL,
    GESCHOSS_DRACHENAUGE,
    GESCHOSS_FEUERBALL,
    GESCHOSS_MINE
};

#define PFEIL_DAMAGE 100
#define KUGEL_DAMAGE 100

class Geschoss : public GameObject
{
private:
    float speed;
    Richtung richtung;
    Spieler *besitzer;
    GeschossTyp typ;
    int tunnelBenutzt;
    int umgelenkt;
    int geschosseGetroffen;
    int schalter;
    int id;

public:
    Geschoss( int id, float speed, GeschossTyp typ, Richtung r, int x, int y, Spieler *besitzer );
    ~Geschoss();
    void invertDirection();
    void addUmlenkung();
    void addGeschossTreffer();
    void addTunnel();
    void addSchalter();
    void setRichtung( Richtung r );
    void tick( double zeit );
    GeschossTyp getTyp() const;
    Spieler *zBesitzer() const;
    Spieler *getBesitzer() const;
    Richtung getRichtung() const;
};

// size: 150x150
class FeuerballTreffer : public GameObject
{
private:
    int id;
    Spieler *besitzer;
    int count;
    float timeLeft;

public:
    FeuerballTreffer( int id, int x, int y, Spieler *besitzer, int maxZeit );
    ~FeuerballTreffer();
    void tick( double zeit );
    bool isOver() const;
    bool makeDamage() const;
    Spieler *zVerursacher() const;
};